package com.provisionnetworks.common;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;

public class IOUtil
{
    public final static int readToBuffer(InputStream is, int length, byte[] buffer) throws IOException
    {
        int offset = 0;
        for (;;)
        {
            if (offset >= length) break;
            int avail = is.available();
            int i;
            if (avail <= 0)
            {
                i = is.read();
                if (i < 0) break;
                avail = is.available();
                buffer[offset++] = (byte) i;
            }

            if (offset + avail >= length) avail = length - offset;
            i = is.read(buffer, offset, avail);
            if (i < 0) break;
            offset += i;
        }
        return offset;
    }
    
    public final static String recvMessage(InputStream is, int maxLength) throws IOException
    {
        byte[] buffer = new byte[maxLength];

        int data = 0;
        int count = 0;
        while ((data = is.read()) > 0 && count < maxLength)
        {
            buffer[count++] = (byte)data;
        }
        
        return new String(buffer, 0, count);
    }
    
    public final static void sendMessage(OutputStream os, String message) throws IOException
    {
        send(os, message.getBytes());
    }
    
    public final static void send(OutputStream os, byte[] data) throws IOException
    {
        os.write(data);
        if (data[data.length - 1] != 0) os.write(0);
        os.flush();
    }

}
