package com.provisionnetworks.common;

public class RC4Cipher
{
    private int[] sbox;
    private int ii, jj;
    
    public RC4Cipher(int[] key)
    {
        int keyLength = key.length;
        this.sbox = new int[256];
        
        int[] ka = new int[256];
        int t;
        int i, j;
     
        for (i = 0; i < 256; i++)
        {
            sbox[i] = i;
            ka[i] = key[i % keyLength] & 0xFF;
        }
        for (i = j = 0; i < 256; i++)
        {
            j = (j + sbox[i] + ka[i]) & 0xff;
            t = sbox[i];
            sbox[i] = sbox[j];
            sbox[j] = t;
        }
        ii = jj = 0;
    }
    
    private final int next()
    {
        int t;
        
        ii = (ii + 1) & 0xff;
        jj = (jj + sbox[ii]) & 0xff;
        t = sbox[ii];
        sbox[ii] = sbox[jj];
        sbox[jj] = t;
        return sbox[(sbox[ii] + sbox[jj]) & 0xff];
    }
    
    public final void encrypt(byte[] in, byte[] out)
    {
        int count = in.length;
        for (int i = 0; i < count; ++i)
        {
            out[i] = (byte)((in[i] & 0xFF) ^ next());
        }
    }
    
    public final void decrypt(byte[] in, byte[] out)
    {
        encrypt(in, out);
    }
}
