package com.provisionnetworks.common;

import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;

public class UICommon
{
    public static void showMessage( Context context, String title, String message )
    {
        final Object waiter = new Object();
        OnClickListener listener = new OnClickListener()
        {
            public void onClick( DialogInterface dialog, int which )
            {
                waiter.notify();
            }
        };
        
        Builder builder = new Builder( null );
        builder.setIcon( android.R.drawable.ic_dialog_info );
        builder.setPositiveButton( "OK", listener );
        builder.setTitle( title );
        builder.setMessage( message );
        builder.create().show();
        
        try
        {
            waiter.wait();
        }
        catch( InterruptedException e ) { }
    }
    
    public static void showErrorMessage( Context context, String title, String message )
    {
        final Object waiter = new Object();
        OnClickListener listener = new OnClickListener()
        {
            public void onClick( DialogInterface dialog, int which )
            {
                waiter.notify();
            }
        };
        
        Builder builder = new Builder( null );
        builder.setInverseBackgroundForced( true );
        builder.setIcon( android.R.drawable.ic_dialog_alert );
        builder.setPositiveButton( "OK", listener );
        builder.setTitle( title );
        builder.setMessage( message );
        builder.create().show();
        
        try
        {
            waiter.wait();
        }
        catch( InterruptedException e ) { }
    }
    
    public static boolean showConfirmDialog( Context context, String title, String message )
    {
        final Object waiter = new Object();
        final String result = "";
        
        OnClickListener yesListener = new OnClickListener()
        {
            public void onClick( DialogInterface dialog, int which )
            {
                result.concat( "true" );
                waiter.notify();
            }
        };
        OnClickListener noListener = new OnClickListener()
        {
            public void onClick( DialogInterface dialog, int which )
            {
                result.concat( "false" );
                waiter.notify();
            }
        };
        
        Builder builder = new Builder( null );
        builder.setIcon( android.R.drawable.ic_dialog_info );
        builder.setPositiveButton( "Yes", yesListener );
        builder.setPositiveButton( "No", noListener );
        builder.setTitle( title );
        builder.setMessage( message );
        builder.create().show();
        
        try
        {
            waiter.wait();
        }
        catch( InterruptedException e ) { }
        
        return Boolean.valueOf( result );
    }
}
