
package com.provisionnetworks.rdp5;

import java.io.IOException;

import net.propero.rdp.Options;
import net.propero.rdp.RdesktopException;
import net.propero.rdp.RdpPacket;
import net.propero.rdp.RdpPacket_Localised;
import net.propero.rdp.crypto.CryptoException;
import net.propero.rdp.rdp5.VChannel;

import org.apache.log4j.Logger;

public class ChannelPNKERB extends VChannel
{
    protected Logger  logger   = Logger.getLogger( ChannelPNKERB.class );

    private PNOptions       pnOptions = null;

    public ChannelPNKERB( Options options, PNOptions pnOptions )
    {
        super( options );
        this.pnOptions = pnOptions;
    }

    public int flags()
    {
        return 0;
        // VChannels.CHANNEL_OPTION_INITIALIZED |
        // VChannels.CHANNEL_OPTION_ENCRYPT_RDP |
        // VChannels.CHANNEL_OPTION_COMPRESS_RDP |
        // VChannels.CHANNEL_OPTION_SHOW_PROTOCOL;
    }

    public String name()
    {
        return "PNKERB";
    }

    public void process( RdpPacket data ) throws RdesktopException,
            IOException, CryptoException
    {
        logger.debug( "PNKERB channel packet" );
        try
        {
            byte packetData[] = new byte[data.getEnd() - data.getPosition()];
            data.copyToByteArray( packetData, 0, data.getPosition(),
                    packetData.length );
            String msg = new String( packetData, "UTF-16LE" );
            logger.debug( "Data=\"" + msg + "\"" );

            if ( (pnOptions.rdpSettings.ticket != null)
                    && (pnOptions.rdpSettings.ticket.length() > 0) )
            {
                logger.info( "Sending ticket (\""
                        + pnOptions.rdpSettings.ticket
                        + "\"over PNKERB channel" );
                RdpPacket_Localised packet = new RdpPacket_Localised(
                        pnOptions.rdpSettings.ticket.length() * 2 + 2 );
                packet.outUnicodeString( pnOptions.rdpSettings.ticket,
                        pnOptions.rdpSettings.ticket.length() * 2 );
                packet.markEnd();
                try
                {
                    send_packet( packet );
                }
                catch( Exception e )
                {
                    logger.error( e.getMessage(), e );
                }
            }
        }
        catch( Exception e )
        {
            logger.error( "Exception", e );
        }
    }
}
