package com.provisionnetworks.rdp5.rdpdr;

import java.io.*;

public class DiskMonitor extends Thread
{
	private static final int timeout = 3000;
	
	private IoRequestPacket irp;
	private boolean closed;
	private File directory;
	private int totalCount;
	private long totalTime;
	
	public DiskMonitor(File directory, IoRequestPacket irp)
	{
		this.closed = false;
		this.directory = directory;
		this.irp = irp;
		
		scanDirectory();
		
		start();
	}
	
    public void run()
    {
    	for (;;) {
    		int totalCount = this.totalCount;
    		long totalTime = this.totalTime;
    		try { sleep(timeout); } catch (Exception e) {}
    		if (this.closed) {
    			this.irp.status = RdpdrChannel.STATUS_CANCELLED;
    			RdpdrChannel.sendIoCompletion(irp);
    			break;
    		}
    		if (true) {
    		scanDirectory();
    		if ((totalCount != this.totalCount) || (totalTime != this.totalTime)) {
    			this.irp.status = RdpdrChannel.STATUS_SUCCESS;
    			RdpdrChannel.sendIoCompletion(this.irp);
    			break;
    		}
    		}
    	}
    }
    
    public void close()
    {
    	this.interrupt();
    	this.closed = true;
    }
    
    private void scanDirectory()
    {
    	File[] files = directory.listFiles();
    	
    	this.totalCount = 0;
    	this.totalTime = 0;

    	for (int i = 0; i < files.length; i++) {
    		this.totalTime += files[i].lastModified();
    		this.totalCount++;
    	}
    }
}
