package com.provisionnetworks.rdp5.rdpdr;

//import javax.print.*;
import net.propero.rdp.*;

public class PrinterDevice extends Device
{
	protected PrinterDevice(int deviceType, String deviceName) {
		super(deviceType, deviceName);
		// TODO Auto-generated constructor stub
	}

	//protected PrintService printService = null;
	protected String printerName = null;
	protected String driverName = null;

	protected PrintJobInfo[] printJobInfo = null;
	
	protected static final int MAX_JOBS = 100;
	
	/*
	public PrinterDevice(String deviceName, PrintService printService) {
		super(RdpdrChannel.RDPDR_DTYP_PRINTER, deviceName);
		this.printService = printService;
		this.printerName = printService.getName();
		this.driverName = "HP LaserJet 4100 Series PS";
		this.printJobInfo = new PrintJobInfo[MAX_JOBS];
	}
	*/
	
	public String getPrinterName() {
		return this.printerName;
	}
	
	public String getDriverName() {
		return this.driverName;
	}
	
	public void processIoRequest(IoRequestPacket irp)
	{
		irp.status = RdpdrChannel.STATUS_NOT_IMPLEMENTED;
		
    	switch (irp.majorFunction)
    	{
    	case RdpdrChannel.IRP_MJ_CREATE:
    		irp.status = this.create(irp);
    		break;
    	
    	case RdpdrChannel.IRP_MJ_CLOSE:
    		irp.status = this.close(irp);
    		break;
    	
    	case RdpdrChannel.IRP_MJ_WRITE:
    		irp.status = this.write(irp);
    		break;
    	default:
    		break;
    	}
	}
	
	private int create(IoRequestPacket irp)
	{
		int jobId = allocateJobHandle();
		//printJobInfo[jobId] = new PrintJobInfo(printService);

		RdpPacket_Localised result = new RdpPacket_Localised(4);
		result.setLittleEndian32(jobId);

		irp.result = result;

		return RdpdrChannel.STATUS_SUCCESS;
	}
	
	private int close(IoRequestPacket irp)
	{
		int jobId = irp.fileId;
		
		if (!isValidJobHandle(jobId)) {
			return RdpdrChannel.STATUS_INVALID_HANDLE;
		}
		
		PrintJobInfo printJobInfo = this.printJobInfo[jobId];
		printJobInfo.close();
		this.printJobInfo[jobId] = null;

		return RdpdrChannel.STATUS_SUCCESS;
	}
	
	private int write(IoRequestPacket irp)
	{	
		int jobId = irp.fileId;
		RdpPacket_Localised packet = irp.packet;
		
		int length = packet.getLittleEndian32();
		long offset = packet.getLittleEndian64();
		packet.incrementPosition(20);
		
		byte[] buffer = null;
		if (length > 0)
		{
			buffer = new byte[length];
			packet.copyToByteArray(buffer, 0, packet.getPosition(), length);
			packet.incrementPosition(length);
		}

		if (!isValidJobHandle(jobId)) {
			return RdpdrChannel.STATUS_INVALID_HANDLE;
		}
		
		PrintJobInfo printJobInfo = this.printJobInfo[jobId];
		printJobInfo.appendData(buffer);

		RdpPacket_Localised result = new RdpPacket_Localised(4);
		result.setLittleEndian32(buffer.length);
		
		irp.result = result;
		
		return RdpdrChannel.STATUS_SUCCESS;
	}
	
	////////////////////////////////////////////////////////////////////
	//
	// Utility Methods
	//
	protected int allocateJobHandle()
	{
		for (int i = 0; i < MAX_JOBS; i++)
		{
			if (this.printJobInfo[i] == null) return i;
		}
		return -1;
	}
	
	protected boolean isValidJobHandle(int jobId)
	{
		return (jobId >= 0) && (jobId < MAX_JOBS) && (this.printJobInfo[jobId] != null) ? true : false;
	}	
}
