package net.propero.rdp.orders.emfplus;

public class EmfPlusBitmap extends EmfPlusImage {
    private int width;   // MUST be ignored
    private int height;   // MUST be ignored
    private int stride;   // MUST be ignored
    private int pixelFormat;   // MUST be ignored
    private int bitmapType; // MUST be BitmapDataTypeCompressed
    private byte[] imageData;
    
    public EmfPlusBitmap(OrderBuffer buffer) {
    	super(buffer);
    	this.width = buffer.getLittleEndian32();
    	this.height = buffer.getLittleEndian32();
    	this.stride = buffer.getLittleEndian32();
    	this.pixelFormat = buffer.getLittleEndian32();
    	this.bitmapType = buffer.getLittleEndian32();
    	
    	final int recordHeaderSize = 8;
    	final int objectHeaderSize = 4 + recordHeaderSize;
    	final int imageHeaderSize = 4 + objectHeaderSize;
    	final int bitmapHeaderSize = 5 * 4 + imageHeaderSize;
    	int dataSize = this.getSize() - bitmapHeaderSize;
    	this.imageData = new byte[dataSize];
    	buffer.copyToByteArray(imageData, 0, buffer.getPosition(), dataSize);
    	buffer.setPosition(buffer.getPosition() + dataSize);
    }
    
    public int getBitmapType() {
    	return bitmapType;
    }
    
    public byte[] getImageData() {
    	return imageData;
    }
    
}
