package net.propero.rdp.orders.emfplus;

public class EmfPlusComment extends EmfPlusRecord {

	private byte[] data = null;
	
	public EmfPlusComment(OrderBuffer buffer) {
		super(buffer);
		final int unknownSymbolSize = 1;
		final int commentHeaderSize = 8;
		int dataSize = this.size - commentHeaderSize - unknownSymbolSize;
		this.data = new byte[dataSize];
		buffer.copyToByteArray(this.data, 0, buffer.getPosition(), dataSize);
		buffer.incrementPosition(dataSize + unknownSymbolSize); //last byte in buffer contains unknown symbol 
	}
	
	public byte[] getCommentData() {
		return data;
	}
	
}
