package net.propero.rdp.orders.emfplus;

import quest.androidport.Rectangle2D;

public class EmfPlusDrawImage extends EmfPlusRecord{
	private boolean cBit = false;
	private Integer imageAttrId = null;
	private int srcUnit = 0;
	private Rectangle2D.Float srcRect = null;
	private Rectangle2D.Float dstRect = null;
	
	public EmfPlusDrawImage(OrderBuffer buffer) {
		super(buffer);
		this.cBit = (((flags >> 14) & 1) == 1);
		this.imageAttrId = Integer.valueOf(buffer.getLittleEndian32());
		this.srcUnit = buffer.getLittleEndian32();
		this.srcRect = new Rectangle2D.Float();
		this.dstRect = new Rectangle2D.Float();
		this.srcRect.x = Float.intBitsToFloat(buffer.getLittleEndian32());
		this.srcRect.y = Float.intBitsToFloat(buffer.getLittleEndian32());
		this.srcRect.width = Float.intBitsToFloat(buffer.getLittleEndian32());
		this.srcRect.height = Float.intBitsToFloat(buffer.getLittleEndian32());
		
		if(this.getCbit())
		{
			this.dstRect.x = buffer.getLittleEndian16();
			this.dstRect.y = buffer.getLittleEndian16();
			this.dstRect.width = buffer.getLittleEndian16();
			this.dstRect.height = buffer.getLittleEndian16();
		}
		else
		{
			this.dstRect.x = Float.intBitsToFloat(buffer.getLittleEndian32());
			this.dstRect.y = Float.intBitsToFloat(buffer.getLittleEndian32());
			this.dstRect.width = Float.intBitsToFloat(buffer.getLittleEndian32());
			this.dstRect.height = Float.intBitsToFloat(buffer.getLittleEndian32());
		}
	}
	
	public int getSrcUnit() {
		return srcUnit;
	}
	
	public boolean getCbit()
	{
		return cBit;
	}
	
	public Integer getImageAttrID() {
		return imageAttrId;
	}
	
	public Rectangle2D.Float getSourceRect() {
		return srcRect;
	}
	
	public Rectangle2D.Float getDestRect() {
		return dstRect;
	}
}
