package net.propero.rdp.orders.emfplus;

public class EmfPlusPathPointTypeRLE implements IEmfPlusPathPointType {
	
	private int flags = 0;
	private int pointType = 0;
	private boolean pointBbit = false;
	private int runCount = 0;
	private int pointFlags = 0;
	
	public EmfPlusPathPointTypeRLE(OrderBuffer buffer) {
		this.flags = buffer.getLittleEndian16();
		this.pointBbit = (((flags & 0xFC) >> 2) == 1);
		this.runCount = ((flags & 0xFC) >> 2);
		this.pointType = ((flags & 0xFF00) >> 8);
		this.pointFlags = ((flags & 0xF0) >> 4);
	}
	
	public boolean getB()
	{
		return pointBbit;
	}
	
	public int getRunCount()
	{
		return runCount;
	}
	
	public int getPointType()
	{
		return pointType;
	}
	
	public int getPointFlags()
	{
		return pointFlags;
	}
}
