package net.propero.rdp.orders.emfplus;

import org.apache.log4j.Logger;

import quest.androidport.Rectangle2D;

import net.propero.rdp.orders.emfplus.enumerations.RegionNodeDataTypeEnumeration;

public class EmfPlusRegionNode {
	
	private Logger logger = Logger.getLogger(EmfPlusRegionNode.class);
	
    private int type = 0;
    
    private EmfPlusRegionNodePath path = null;
    
    //Not supported in current version
    private Rectangle2D.Float rectF = null;
    private EmfPlusRegionNode leftChild = null;
    private EmfPlusRegionNode rightChild = null;
    
    public EmfPlusRegionNode(OrderBuffer buffer) {
    	this.type = buffer.getLittleEndian32();
  		switch(this.type)
  		{
  		case RegionNodeDataTypeEnumeration.RegionNodeDataTypePath:
  			this.path = new EmfPlusRegionNodePath(buffer);
  			break;
  		case RegionNodeDataTypeEnumeration.RegionNodeDataTypeRect:
  			this.rectF.x = Float.intBitsToFloat(buffer.getLittleEndian32());
  			this.rectF.y = Float.intBitsToFloat(buffer.getLittleEndian32());
  			this.rectF.width = Float.intBitsToFloat(buffer.getLittleEndian32());
  			this.rectF.height = Float.intBitsToFloat(buffer.getLittleEndian32());
  			break;
  		case RegionNodeDataTypeEnumeration.RegionNodeDataTypeEmpty:
  			break;
  		default:
  			logger.error("Unimplemented node type: " + Integer.toHexString(this.type));
  			break;
  		}
    }
    
    public int getType() {
    	return type;
    }
    
    public EmfPlusRegionNodePath getRegionNodePath() {
    	return path;
    }
}
