package quest.android.appportal.controller;

import org.apache.log4j.Logger;

import quest.android.appportal.R;

import android.app.Activity;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.ViewAnimator;

public class AboutDialog extends DialogController
{
    private Logger logger      = Logger.getLogger( HelpDialog.class );

    private DialogController helpDialog = null;

    public AboutDialog( Activity activity )
    {
        super( activity );
    }

    public void showDialog()
    {
        logger.debug( "About dialog showing" );
        
        this.setContentView( R.layout.about );

        updateDialog();
        updateOrientation( true );

        dialog.show();
    }

    protected void updateDialog()
    {
        final ViewAnimator animator = (ViewAnimator) dialog
                .findViewById( R.id.AboutChanger );
        WebView webView = (WebView) dialog
                .findViewById( R.id.AboutWebView );
        webView.loadUrl( "file:///android_asset/help/legaltext.htm" );

        final Button backButton = (Button) dialog
                .findViewById( R.id.AboutBackButton );
        Button doneButton = (Button) dialog
                .findViewById( R.id.AboutDoneButton );

        ListView generalList = (ListView) dialog
                .findViewById( R.id.AboutList );

        ArrayAdapter<String> adapter = new ArrayAdapter<String>( activity,
                R.layout.farm_settings_location_list_item, resources.getStringArray( R.array.AboutDialogList ) );
        generalList.setAdapter( adapter );
        int rows = adapter.getCount();
        
        ViewGroup.LayoutParams generalListParams = generalList
                .getLayoutParams();
        generalListParams.height = rows
                * 35 // 35px is items height
                + (rows - 1) * generalList.getDividerHeight()
                + generalList.getPaddingTop() + generalList.getPaddingBottom();
        generalList.setLayoutParams( generalListParams );

        generalList.setOnItemClickListener( new OnItemClickListener()
        {
            public void onItemClick( AdapterView<?> parent, View view,
                    int position, long id )
            {
                switch ( position )
                {
                    case 0:
                        helpDialog = new HelpDialog( activity );
                        helpDialog.showDialog();
                        break;
                    case 1:
                        backButton.setVisibility( View.VISIBLE );
                        animator.setDisplayedChild( 1 );
                        break;
                }
            }
        } );

        doneButton.setOnClickListener( new OnClickListener()
        {
            public void onClick( View v )
            {
                dismiss();
            }
        } );

        backButton.setOnClickListener( new OnClickListener()
        {
            public void onClick( View v )
            {
                backButton.setVisibility( View.INVISIBLE );
                animator.setDisplayedChild( 0 );
            }
        } );
    }

    private void dismiss()
    {
        dialog.dismiss();
    }
    
    public void updateOrientation( boolean isLandscape )
    {
        super.updateOrientation( isLandscape );
        
        if ( helpDialog != null && helpDialog.isShowed() )
        {
            helpDialog.updateOrientation( isLandscape );
        }
    }
}
