package quest.android.appportal.controller;

import quest.android.appportal.R;
import quest.android.appportal.farm.PNFarm;
import quest.android.appportal.farm.PNLocation;
import android.app.Activity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;

public class CredentialController extends DialogController
{
    PNFarm farm = null;
    PNLocation location = null;
    String message = "";
    
    protected CredentialController( Activity activity, PNFarm farm, PNLocation location, String message )
    {
        super( activity );
        this.farm = farm;
        this.location = location;
        this.message = message;
        
        setContentView( R.layout.credentials );
    }

    public void showDialog()
    {
        dialog.findViewById( R.id.CredsOkButton ).setOnClickListener( saveButtonListener );
        dialog.findViewById( R.id.CredsCancelButton ).setOnClickListener( cancelButtonListener );
        
        updateDialog();
        updateOrientation( true );
        
        dialog.show();
    }

    protected void updateDialog()
    {
        EditText username       = (EditText) dialog.findViewById( R.id.CredsUsername );
        EditText password       = (EditText) dialog.findViewById( R.id.CredsPassword );
        EditText domain         = (EditText) dialog.findViewById( R.id.CredsDomain );
        CheckBox saveCreds      = (CheckBox) dialog.findViewById( R.id.CredsSaveCreds );
        TextView serverMessage  = (TextView) dialog.findViewById( R.id.CredsServerMessage );
        
        username.setText( farm.getUsername() );
        password.setText( farm.getPassword() );
        domain.setText( farm.getDomain() );
        saveCreds.setChecked( farm.isSaveCredentials() );
        serverMessage.setText( message );
    }
    
    protected void updateSettings()
    {
        EditText username   = (EditText) dialog.findViewById( R.id.CredsUsername );
        EditText password   = (EditText) dialog.findViewById( R.id.CredsPassword );
        EditText domain     = (EditText) dialog.findViewById( R.id.CredsDomain );
        CheckBox saveCreds  = (CheckBox) dialog.findViewById( R.id.CredsSaveCreds );
        
        farm.setUsername( username.getText().toString() );
        farm.setPassword( password.getText().toString() );
        farm.setDomain( domain.getText().toString() );
        farm.setSaveCredentialsEnabled( saveCreds.isChecked() );
    }

    
    private OnClickListener saveButtonListener = new OnClickListener()
    {
        public void onClick( View v )
        {
            updateSettings();
            
            if ( dialog != null )
            {
                dialog.dismiss();
            }
            
            if ( positiveListener != null )
            {
                positiveListener.onClick( v );
            }
        }
    };
    
    private OnClickListener cancelButtonListener = new OnClickListener()
    {
        public void onClick( View v )
        {
            if ( dialog != null )
            {
                dialog.dismiss();
            }
            
            if ( negativeListener != null )
            {
                negativeListener.onClick( v );
            }
        }
    };
    
    public PNFarm getFarm()
    {
        return farm;
    }
    
    public PNLocation getLocation()
    {
        return location;
    }
}
