
package quest.android.appportal.controller;

import java.util.HashMap;

import org.apache.log4j.Logger;

import quest.android.appportal.R;

import android.app.Activity;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.ViewAnimator;

public class HelpDialog extends DialogController
{
    private Logger logger = Logger.getLogger( HelpDialog.class );

    private HashMap<String, Integer> viewMap    = new HashMap<String, Integer>();

    public HelpDialog( Activity activity )
    {
        super( activity );
    }

    public void showDialog()
    {
        this.setContentView( R.layout.help );

        updateDialog();
        this.updateOrientation( true );

        dialog.show();
    }

    protected void updateDialog()
    {
        final ViewAnimator animator = (ViewAnimator) dialog
                .findViewById( R.id.HelpChanger );
        final Button backButton = (Button) dialog
                .findViewById( R.id.HelpBackButton );
        Button doneButton = (Button) dialog
                .findViewById( R.id.HelpDoneButton );

        ListView generalList = (ListView) dialog
                .findViewById( R.id.HelpGeneralList );
        ListView configList = (ListView) dialog
                .findViewById( R.id.HelpConfigurationList );
        ListView mainViewList = (ListView) dialog
                .findViewById( R.id.HelpMainViewList );
        ListView dekstopToolbarList = (ListView) dialog
                .findViewById( R.id.HelpToolbarList );

        backButton.setTextColor( 0xFF909090 );

        backButton.setOnClickListener( new OnClickListener()
        {
            public void onClick( View v )
            {
                backButton.setTextColor( 0xFF909090 );
                backButton.setEnabled( false );
                animator.setDisplayedChild( 0 );
            }
        } );
        doneButton.setOnClickListener( new OnClickListener()
        {
            public void onClick( View v )
            {
                dismiss();
            }
        } );

        ArrayAdapter<String> adapter = new ArrayAdapter<String>( activity,
                R.layout.farm_settings_location_list_item );
        adapter.add( activity.getString( R.string.help_dialog_vworkspace_connector_for_android_an_overview ) );
        generalList.setAdapter( adapter );
        int rows = adapter.getCount();
        ViewGroup.LayoutParams generalListParams = generalList
                .getLayoutParams();
        generalListParams.height = rows
                * 35 // 35px is items height
                + (rows - 1) * generalList.getDividerHeight()
                + generalList.getPaddingTop() + generalList.getPaddingBottom();
        generalList.setLayoutParams( generalListParams );

        adapter = new ArrayAdapter<String>( activity,
                R.layout.farm_settings_location_list_item );
        adapter.add( activity.getString( R.string.help_dialog_add_farm ) );
        adapter.add( activity.getString( R.string.help_dialog_edit_farm ) );
        adapter.add( activity.getString( R.string.help_dialog_delete_farm ) );
        adapter.add( activity.getString( R.string.help_dialog_add_location ) );
        adapter.add( activity.getString( R.string.help_dialog_edit_location ) );
        adapter.add( activity.getString( R.string.help_dialog_delete_location ) );
        configList.setAdapter( adapter );
        rows = adapter.getCount();
        ViewGroup.LayoutParams configListParams = configList.getLayoutParams();
        configListParams.height = rows
                * 35 // 35px is items height
                + (rows - 1) * configList.getDividerHeight()
                + configList.getPaddingTop() + configList.getPaddingBottom();
        configList.setLayoutParams( configListParams );

        adapter = new ArrayAdapter<String>( activity,
                R.layout.farm_settings_location_list_item );
        adapter.add( activity.getString( R.string.help_dialog_connecting_to_a_vworkspace_farm ) );
        adapter.add( activity.getString( R.string.help_dialog_refreshing_the_application_list ) );
        adapter.add( activity.getString( R.string.help_dialog_changing_the_wallpaper ) );
        adapter.add( activity.getString( R.string.help_dialog_launching_an_application ) );
        adapter.add( activity.getString( R.string.help_dialog_managing_active_connections ) );
        adapter.add( activity.getString( R.string.help_dialog_application_logging ) );
        mainViewList.setAdapter( adapter );
        rows = adapter.getCount();
        ViewGroup.LayoutParams mainViewListParams = mainViewList
                .getLayoutParams();
        mainViewListParams.height = rows
                * 35 // 35px is items height
                + (rows - 1) * mainViewList.getDividerHeight()
                + mainViewList.getPaddingTop()
                + mainViewList.getPaddingBottom();
        mainViewList.setLayoutParams( mainViewListParams );

        adapter = new ArrayAdapter<String>( activity,
                R.layout.farm_settings_location_list_item );
        adapter.add( activity.getString( R.string.help_dialog_using_the_desktop_toolbar ) );
        dekstopToolbarList.setAdapter( adapter );
        rows = adapter.getCount();
        ViewGroup.LayoutParams dekstopToolbarListParams = dekstopToolbarList
                .getLayoutParams();
        dekstopToolbarListParams.height = rows
                * 35 // 35px is items height
                + (rows - 1) * dekstopToolbarList.getDividerHeight()
                + dekstopToolbarList.getPaddingTop()
                + dekstopToolbarList.getPaddingBottom();
        dekstopToolbarList.setLayoutParams( dekstopToolbarListParams );

        generalList.setOnItemClickListener( new OnItemClickListener()
        {
            public void onItemClick( AdapterView<?> parent, View view,
                    int position, long id )
            {
                switch ( position )
                {
                    case 0:
                        updateHelpView( "file:///android_asset/help/overview.htm" );
                        break;
                }
            }
        } );
        configList.setOnItemClickListener( new OnItemClickListener()
        {
            public void onItemClick( AdapterView<?> parent, View view,
                    int position, long id )
            {
                switch ( position )
                {
                    case 0:
                        updateHelpView( "file:///android_asset/help/addfarm.htm" );
                        break;
                    case 1:
                        updateHelpView( "file:///android_asset/help/editfarm.htm" );
                        break;
                    case 2:
                        updateHelpView( "file:///android_asset/help/deletefarm.htm" );
                        break;
                    case 3:
                        updateHelpView( "file:///android_asset/help/addlocation.htm" );
                        break;
                    case 4:
                        updateHelpView( "file:///android_asset/help/editlocation.htm" );
                        break;
                    case 5:
                        updateHelpView( "file:///android_asset/help/deletelocation.htm" );
                        break;
                }
            }
        } );
        mainViewList.setOnItemClickListener( new OnItemClickListener()
        {
            public void onItemClick( AdapterView<?> parent, View view,
                    int position, long id )
            {
                switch ( position )
                {
                    case 0:
                        updateHelpView( "file:///android_asset/help/connectingtoafarm.htm" );
                        break;
                    case 1:
                        updateHelpView( "file:///android_asset/help/refreshbutton.htm" );
                        break;
                    case 2:
                        updateHelpView( "file:///android_asset/help/changingwallpaper.htm" );
                        break;
                    case 3:
                        updateHelpView( "file:///android_asset/help/applications.htm" );
                        break;
                    case 4:
                        updateHelpView( "file:///android_asset/help/activeconnections.htm" );
                        break;
                    case 5:
                        updateHelpView( "file:///android_asset/help/applogging.htm" );
                        break;
                }
            }
        } );
        dekstopToolbarList.setOnItemClickListener( new OnItemClickListener()
        {
            public void onItemClick( AdapterView<?> parent, View view,
                    int position, long id )
            {
                switch ( position )
                {
                    case 0:
                        updateHelpView( "file:///android_asset/help/desktoptoolbar.htm" );
                        break;
                }
            }
        } );

        mapHelpViews();
    }

    private void mapHelpViews()
    {
        addNewWebView( "file:///android_asset/help/overview.htm" );

        addNewWebView( "file:///android_asset/help/addfarm.htm" );
        addNewWebView( "file:///android_asset/help/editfarm.htm" );
        addNewWebView( "file:///android_asset/help/deletefarm.htm" );
        addNewWebView( "file:///android_asset/help/addlocation.htm" );
        addNewWebView( "file:///android_asset/help/editlocation.htm" );
        addNewWebView( "file:///android_asset/help/deletelocation.htm" );

        addNewWebView( "file:///android_asset/help/connectingtoafarm.htm" );
        addNewWebView( "file:///android_asset/help/refreshbutton.htm" );
        addNewWebView( "file:///android_asset/help/changingwallpaper.htm" );
        addNewWebView( "file:///android_asset/help/applications.htm" );
        addNewWebView( "file:///android_asset/help/activeconnections.htm" );
        addNewWebView( "file:///android_asset/help/applogging.htm" );

        addNewWebView( "file:///android_asset/help/desktoptoolbar.htm" );
    }

    private void addNewWebView( String url )
    {
        ViewAnimator animator = (ViewAnimator) dialog
                .findViewById( R.id.HelpChanger );
        WebView webView = getWebViewForResource( url );
        int index = animator.getChildCount();
        viewMap.put( url, index );
        animator.addView( webView );
    }

    private WebView getWebViewForResource( String url )
    {
        try
        {
            WebView webView = new WebView( activity );
            webView.loadUrl( url );
            return webView;
        }
        catch( Exception e )
        {
            logger.error( e.getMessage(), e );
            return null;
        }
    }

    private void updateHelpView( String url )
    {
        try
        {
            ViewAnimator animator = (ViewAnimator) dialog
                    .findViewById( R.id.HelpChanger );
            Button backButton = (Button) dialog
                    .findViewById( R.id.HelpBackButton );

            backButton.setTextColor( 0xFFFFFFFF );
            backButton.setEnabled( true );

            animator.setDisplayedChild( viewMap.get( url ) );
        }
        catch( Exception e )
        {
            logger.error( e.getMessage(), e );
        }
    }

    private void dismiss()
    {
        dialog.dismiss();
    }

}
