package quest.android.appportal.model;

import java.util.List;

import android.app.Activity;
import android.view.View;

import com.provisionnetworks.common.OnRdpControlListener;

import quest.android.appportal.connection.PNApplication;
import quest.android.appportal.controller.OnApplicationsListLoadListener;
import quest.android.appportal.farm.PNFarm;
import quest.android.appportal.farm.PNLocation;

public interface IModel
{
    public void onExit() throws Throwable;
    public void reset( Activity activity );
    
    public List<PNFarm> getFarmList();
    
    public PNFarm createNewFarm( String name );
    public boolean addFarm( PNFarm farm );
    public PNFarm getFarm( String farmName );
    public PNFarm getFarmByUuid( String uuid );
    public PNFarm getConnectedFarm();
    public void sortFarmsByName();
    
    public void deleteSavedFarms();
    public void deleteFarm( String uuid );
    
    public void save();
    
    public void getApplicationList( PNFarm farm, PNLocation location );
    public void setOnApplicationsListListener( OnApplicationsListLoadListener listener );
    public String testConnection( String protocol, List<String> servers, int port, String username, String password, String domain );
    
    public String getPathToDefaultWallpaper();
    public String getPasscode();
    public boolean isLoggingEnabled();
    
    public void setPathToDefaultWallpaper( String path );
    public void setPasscode( String passcode );
    public void setLoggingEnabled( boolean enabled );
    
    public void startRdpConnection( PNApplication application, PNFarm farm, PNLocation location );
    public void setOnRdpControlListener( OnRdpControlListener listener );
    public List<RdpThread> getRdpThreadList();
    public List<View> getRdpViewList();
    
}
