package quest.android.appportal.view.custom;

import java.util.ArrayList;
import java.util.List;

import quest.android.appportal.R;
import quest.android.appportal.connection.PNApplication;
import android.content.Context;
import android.graphics.Bitmap;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class ApplicationsGridAdapter extends BaseAdapter
{
    private LayoutInflater mInflater;
    
    List<PNApplication> applications = null;
    
    public ApplicationsGridAdapter( Context context, List<PNApplication> items ) 
    {
        mInflater = LayoutInflater.from(context);
        this.applications = items == null ? new ArrayList<PNApplication>() : items;
    }

    public int getCount() 
    {
        return applications.size();
    }

    public Object getItem(int position) 
    {
        return applications.get( position );
    }

    public long getItemId(int position) 
    {
        return 0;
    }

    // create a new ImageView for each item referenced by the Adapter
    public View getView(int position, View convertView, ViewGroup parent) 
    {
        ViewHolder holder;

        if (convertView == null)
        {
            convertView = mInflater.inflate(R.layout.main_view_app_item, null);

            convertView.setPadding( 5, 5, 5, 5 );
            
            holder = new ViewHolder();
            holder.icon = (ImageView) convertView.findViewById(R.id.Icon);
            holder.text = (TextView) convertView.findViewById(R.id.AppName);
            
            convertView.setTag(holder);
        }
        else 
        {
            holder = (ViewHolder) convertView.getTag();
        }
        
        Bitmap icon = applications.get( position ).getLargeIcon();
        
        if ( icon == null )
        {
            holder.icon.setImageResource( android.R.drawable.sym_def_app_icon );
        }
        else
        {
            holder.icon.setImageBitmap( icon );
        }
        
        //holder.icon.setLayoutParams( new LinearLayout.LayoutParams(64, 64) );
        holder.text.setText( applications.get( position ).getName() );
        
        return convertView;
    }

    private static class ViewHolder 
    {
        private ImageView icon = null;
        private TextView  text = null;
    }

}
