package quest.android.appportal.view.custom;

import java.util.List;

import org.apache.log4j.Logger;

import quest.android.appportal.R;
import quest.android.appportal.farm.PNLocation;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class LocationListAdapter extends BaseAdapter
{
    private Logger logger = Logger.getLogger( LocationListAdapter.class );
    
    private LayoutInflater mInflater;
    
    private List<PNLocation> locations;
    
    public LocationListAdapter( Context context, List<PNLocation> items )
    {
        logger.debug( "Location list adapter created." );
        
        mInflater = LayoutInflater.from(context);
        this.locations = items;
    }
    
    public int getCount()
    {
        return locations.size();
    }

    public Object getItem( int position )
    {
        return locations.get( position );
    }

    public long getItemId( int position )
    {
        return position;
    }

    public View getView( int position, View convertView, ViewGroup parent )
    {
        ViewHolder holder;

        if (convertView == null)
        {
            convertView = mInflater.inflate(R.layout.location_list_item, null);

            holder = new ViewHolder();
            holder.text = (TextView) convertView.findViewById(R.id.LocationListTextItem);
            convertView.setTag(holder);
        }
        else 
        {
            holder = (ViewHolder) convertView.getTag();
        }
       
        holder.text.setText( locations.get( position ).getName() );
        
        return convertView;
    }

    private static class ViewHolder
    {
        private TextView  text = null;
    }
    
}
