package quest.android.appportal.view.custom;

import android.view.MotionEvent;
import android.view.GestureDetector.SimpleOnGestureListener;

public class SwipeDetector extends SimpleOnGestureListener
{
    
    private static final int SWIPE_MIN_DISTANCE = 50;
    private static final int SWIPE_MAX_OFF_PATH = 30;
    private static final int SWIPE_THRESHOLD_VELOCITY = 500;
    
    public boolean onFling( MotionEvent e1, MotionEvent e2, float velocityX, float velocityY ) 
    {
        try
        {
            if ( Math.abs(e1.getY() - e2.getY()) > SWIPE_MAX_OFF_PATH )
            {
                return false;
            }
            
            if ( (e1.getX() - e2.getX() > SWIPE_MIN_DISTANCE) && (Math.abs(velocityX) > SWIPE_THRESHOLD_VELOCITY) )
            {
                // right to left swipe
                return true;
            }
            else if ( (e2.getX() - e1.getX() > SWIPE_MIN_DISTANCE) && (Math.abs(velocityX) > SWIPE_THRESHOLD_VELOCITY) )
            {
                // left to right swipe
                return true;
            }
        }
        catch (Exception e)
        {
            // nothing
        }
        return false;
    }

}