package quest.android.appportal.view.custom;

import java.util.List;

import android.content.Context;
import android.graphics.Bitmap;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;

public class WallpaperGalleryAdapter extends BaseAdapter 
{
    int mGalleryItemBackground;
    private Context context;

    private List<Object> imageIds = null;

    public WallpaperGalleryAdapter( Context context, List<Object> imageIds ) 
    {
        this.context = context;
        this.imageIds = imageIds;
    }

    public int getCount() 
    {
        return imageIds.size();
    }

    public Object getItem(int position) 
    {
        return position;
    }

    public long getItemId(int position) 
    {
        return position;
    }

    public View getView(int position, View convertView, ViewGroup parent) 
    {
        if ( convertView != null )
        {
            return convertView;
        }
        
        ImageView i = new ImageView( context );

        Object image = imageIds.get( position );
        
        if ( image instanceof Bitmap )
        {
            i.setImageBitmap( (Bitmap)image );
        }
        
        i.setLayoutParams( new GridView.LayoutParams(100, 100) );
        i.setScaleType( ImageView.ScaleType.FIT_CENTER );
        i.setBackgroundResource( mGalleryItemBackground );

        i.setTag( image );
        
        return i;
    }
}